=== debian/changelog ===
golang-github-sigstore-protobuf-specs (0.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #1060853)

 -- Simon Josefsson <simon@josefsson.org>  Mon, 15 Jan 2024 18:51:07 +0100
