=== debian/control ===
Source: golang-github-sigstore-protobuf-specs
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-google-genproto-dev,
 golang-google-protobuf-dev,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs.git
Homepage: https://github.com/sigstore/protobuf-specs
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/sigstore/protobuf-specs

Package: golang-github-sigstore-protobuf-specs-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-google-genproto-dev,
 golang-google-protobuf-dev,
 ${misc:Depends},
Description: Sigstore Protocol Buffer code (library)
 Provides protobuf specifications for Sigstore messages.
 .
 This package contains the library.
