## golang-github-sigstore-protobuf-specs 0.3.2

=== debian/changelog ===
golang-github-sigstore-protobuf-specs (0.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Fix watch file to avoid non-release tags.
  * Standards-Version: 4.7.0

 -- Simon Josefsson <simon@josefsson.org>  Fri, 25 Oct 2024 14:39:09 +0200
