## golang-github-sigstore-protobuf-specs 0.3.3

=== Makefile ===
--- 
+++ 
@@ -13,11 +13,13 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-PROTOC_IMAGE=protobuf-specs-build
-JSONSCHEMA_IMAGE=jsonschema-specs-build
+PROTOC_IMAGE = protobuf-specs-build
+JSONSCHEMA_IMAGE = jsonschema-specs-build
+
+RUST_ACTION ?= run -p sigstore-protobuf-specs-codegen
 
 # generate all language protobuf code
-all: go python typescript ruby rust jsonschema
+all: go python typescript ruby jsonschema rust
 
 # generate Go protobuf code
 go: docker-image
@@ -52,23 +54,21 @@
 
 jsonschema: docker-image-jsonschema
 	@echo "Generating JSON schema files"
+	mkdir -p gen/jsonschema/schemas
 	docker run \
 	       -v ${PWD}:/defs \
 	       --entrypoint sh \
 	       ${JSONSCHEMA_IMAGE} \
 	       -c "cd defs/gen/jsonschema && ./jsonschema.sh -I ../../protos -I /googleapis/ --jsonschema_out=schemas ../../protos/*.proto"
 
-gen/pb-rust/schemas: jsonschema
-	cp -r gen/jsonschema/schemas gen/pb-rust
-
-rust: docker-image gen/pb-rust/schemas
-	@echo "Generating rust protobuf files"
+rust: docker-image
 	docker run \
 		--platform linux/amd64 \
 		-v ${PWD}:/defs \
 		-e "RUST_BACKTRACE=1" \
+		-e "CARGO_REGISTRY_TOKEN" \
 		--entrypoint bash ${PROTOC_IMAGE} \
-		-c "cd gen/pb-rust && cargo build"
+		-c "cd gen/pb-rust && cargo ${RUST_ACTION}"
 
 # docker already does its own caching so we can attempt a build every time
 .PHONY: docker-image
@@ -95,8 +95,8 @@
 		gen/pb-typescript/src/__generated__ \
 		gen/pb-python/sigstore_protobuf_specs/dev \
 		gen/pb-python/sigstore_protobuf_specs/io \
-		gen/pb-rust/schemas \
-		gen/pb-rust/target
+		gen/pb-rust/target \
+		gen/jsonschema/schemas
 	docker rmi -f ${PROTOC_IMAGE}
 
 help:
