=== debian/changelog ===
golang-github-sigstore-protobuf-specs (0.3.3-1) unstable; urgency=medium

  * New upstream version 0.3.3
  * d/salsa-ci.yml: Build rdeps.  Tighten lintian/autopkgtest checks.
  * Bump d/* copyright years.
  * Add d/lrc.config for licensecheck.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 15 Jan 2025 13:46:50 +0100
