=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  golang-any,
  golang-google-genproto-dev,
  golang-google-protobuf-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs.git
 Homepage: https://github.com/sigstore/protobuf-specs
