=== debian/changelog ===
golang-github-sigstore-protobuf-specs (0.4.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 10 Apr 2025 09:35:17 +0200

golang-github-sigstore-protobuf-specs (0.4.1-1) experimental; urgency=medium

  * New upstream version 0.4.1
  * Standards-Version: 4.7.2.
  * Use dh-sequence-golang.
  * Exclude protoc-builder due to non-Go *.go file.
  * Run go generate.
  * gbp.conf: Use debian-branch=debian/latest.
  * Add Breaks: on too old sigstore-go.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 09 Apr 2025 22:45:51 +0200
