=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
- dh-golang,
+ dh-sequence-golang,
  golang-any,
  golang-google-genproto-dev,
  golang-google-protobuf-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs.git
 Homepage: https://github.com/sigstore/protobuf-specs
@@ -25,6 +25,8 @@
  golang-google-genproto-dev,
  golang-google-protobuf-dev,
  ${misc:Depends},
+Breaks:
+ golang-github-sigstore-sigstore-go-dev (<< 0.7.1~),
 Description: Sigstore Protocol Buffer code (library)
  Provides protobuf specifications for Sigstore messages.
  .
