=== debian/changelog ===
golang-github-sigstore-protobuf-specs (0.5.0-1) unstable; urgency=medium

  * New upstream version 0.5.0
  * Use watch v5.
  * Drop Rules-Requires-Root: no.
  * Modernize Salsa CI.
  * Bump upstream copyright years.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 09 Oct 2025 08:16:00 +0200
