=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-sigstore-protobuf-specs.git
 Homepage: https://github.com/sigstore/protobuf-specs
-Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/sigstore/protobuf-specs
 
 Package: golang-github-sigstore-protobuf-specs-dev
